]> git.ipfire.org Git - thirdparty/git.git/blame - git-rebase.sh
am: remove support for -d .dotest
[thirdparty/git.git] / git-rebase.sh
CommitLineData
59e6b23a
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano.
4#
5
1b1dce4b 6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
031321c6
SE
7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8same name. When the --onto option is provided the new branch starts
9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10It then attempts to create a new commit for each commit from the original
11<branch> that does not exist in the <upstream> branch.
69a60af5 12
031321c6
SE
13It is possible that a merge failure will prevent this process from being
14completely automatic. You will have to resolve any such merge failure
cc120056
SE
15and run git rebase --continue. Another option is to bypass the commit
16that caused the merge failure with git rebase --skip. To restore the
17original <branch> and remove the .dotest working files, use the command
18git rebase --abort instead.
69a60af5 19
031321c6
SE
20Note that if <branch> is not specified on the command line, the
21currently checked out branch is used. You must be in the top
22directory of your project to start (or continue) a rebase.
e646c9c8 23
031321c6 24Example: git-rebase master~1 topic
e646c9c8 25
031321c6
SE
26 A---B---C topic A'\''--B'\''--C'\'' topic
27 / --> /
28 D---E---F---G master D---E---F---G master
e646c9c8 29'
533b7039
JH
30
31SUBDIRECTORY_OK=Yes
8f321a39 32OPTIONS_SPEC=
ae2b0f15 33. git-sh-setup
f9474132 34set_reflog_action rebase
7eff28a9 35require_work_tree
533b7039 36cd_to_toplevel
4282c4fb 37
cc120056
SE
38RESOLVEMSG="
39When you have resolved this problem run \"git rebase --continue\".
40If you would prefer to skip this patch, instead run \"git rebase --skip\".
41To restore the original branch and stop rebasing run \"git rebase --abort\".
42"
e646c9c8 43unset newbase
a06f678e 44strategy=recursive
58634dbf
EW
45do_merge=
46dotest=$GIT_DIR/.dotest-merge
47prec=4
b758789c 48verbose=
67dad687 49git_am_opt=
58634dbf
EW
50
51continue_merge () {
52 test -n "$prev_head" || die "prev_head must be defined"
53 test -d "$dotest" || die "$dotest directory does not exist"
54
5be60078 55 unmerged=$(git ls-files -u)
58634dbf
EW
56 if test -n "$unmerged"
57 then
58 echo "You still have unmerged paths in your index"
9b07873a 59 echo "did you forget to use git add?"
66eb64cb 60 die "$RESOLVEMSG"
58634dbf
EW
61 fi
62
889a50e9 63 cmt=`cat "$dotest/current"`
38762c47 64 if ! git diff-index --quiet HEAD --
58634dbf 65 then
7afa845e 66 if ! git-commit -C "$cmt"
f0ef0596
EW
67 then
68 echo "Commit failed, please do not call \"git commit\""
69 echo "directly, but instead do one of the following: "
70 die "$RESOLVEMSG"
71 fi
7afa845e 72 printf "Committed: %0${prec}d " $msgnum
58634dbf 73 else
7afa845e 74 printf "Already applied: %0${prec}d " $msgnum
58634dbf 75 fi
c7965afd 76 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
58634dbf 77
5be60078 78 prev_head=`git rev-parse HEAD^0`
58634dbf 79 # save the resulting commit so we can read-tree on it later
58634dbf
EW
80 echo "$prev_head" > "$dotest/prev_head"
81
82 # onto the next patch:
83 msgnum=$(($msgnum + 1))
5887ac82 84 echo "$msgnum" >"$dotest/msgnum"
58634dbf
EW
85}
86
87call_merge () {
889a50e9 88 cmt="$(cat "$dotest/cmt.$1")"
58634dbf 89 echo "$cmt" > "$dotest/current"
5be60078 90 hd=$(git rev-parse --verify HEAD)
6fd2f5e6 91 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
889a50e9
JS
92 msgnum=$(cat "$dotest/msgnum")
93 end=$(cat "$dotest/end")
0bb733c9 94 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
889a50e9 95 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
0bb733c9
SP
96 export GITHEAD_$cmt GITHEAD_$hd
97 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
58634dbf
EW
98 rv=$?
99 case "$rv" in
100 0)
0bb733c9 101 unset GITHEAD_$cmt GITHEAD_$hd
9e4bc7dd 102 return
58634dbf
EW
103 ;;
104 1)
b4372ef1 105 git rerere
66eb64cb 106 die "$RESOLVEMSG"
58634dbf
EW
107 ;;
108 2)
109 echo "Strategy: $rv $strategy failed, try another" 1>&2
66eb64cb 110 die "$RESOLVEMSG"
58634dbf
EW
111 ;;
112 *)
113 die "Unknown exit code ($rv) from command:" \
114 "git-merge-$strategy $cmt^ -- HEAD $cmt"
115 ;;
116 esac
117}
118
6fd2f5e6
JS
119move_to_original_branch () {
120 test -z "$head_name" &&
121 head_name="$(cat "$dotest"/head-name)" &&
122 onto="$(cat "$dotest"/onto)" &&
123 orig_head="$(cat "$dotest"/orig-head)"
124 case "$head_name" in
125 refs/*)
126 message="rebase finished: $head_name onto $onto"
127 git update-ref -m "$message" \
128 $head_name $(git rev-parse HEAD) $orig_head &&
129 git symbolic-ref HEAD $head_name ||
130 die "Could not move back to $head_name"
131 ;;
132 esac
133}
134
58634dbf 135finish_rb_merge () {
6fd2f5e6 136 move_to_original_branch
58634dbf
EW
137 rm -r "$dotest"
138 echo "All done."
139}
140
1b1dce4b
JS
141is_interactive () {
142 test -f "$dotest"/interactive ||
822f7c73 143 while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
1b1dce4b
JS
144 shift
145 done && test -n "$1"
146}
147
148is_interactive "$@" && exec git-rebase--interactive "$@"
149
822f7c73 150while test $# != 0
e646c9c8
JH
151do
152 case "$1" in
031321c6 153 --continue)
5be60078 154 git diff-files --quiet || {
06aff47b 155 echo "You must edit all merge conflicts and then"
9b07873a 156 echo "mark them as resolved using git add"
031321c6 157 exit 1
06aff47b 158 }
58634dbf
EW
159 if test -d "$dotest"
160 then
889a50e9
JS
161 prev_head=$(cat "$dotest/prev_head")
162 end=$(cat "$dotest/end")
163 msgnum=$(cat "$dotest/msgnum")
164 onto=$(cat "$dotest/onto")
58634dbf
EW
165 continue_merge
166 while test "$msgnum" -le "$end"
167 do
168 call_merge "$msgnum"
169 continue_merge
170 done
171 finish_rb_merge
172 exit
173 fi
3f735b66
JS
174 head_name=$(cat .dotest/head-name) &&
175 onto=$(cat .dotest/onto) &&
176 orig_head=$(cat .dotest/orig-head) &&
177 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
178 move_to_original_branch
cc120056
SE
179 exit
180 ;;
181 --skip)
fb6e4e1f 182 git reset --hard HEAD || exit $?
58634dbf
EW
183 if test -d "$dotest"
184 then
b4372ef1 185 git rerere clear
889a50e9
JS
186 prev_head=$(cat "$dotest/prev_head")
187 end=$(cat "$dotest/end")
188 msgnum=$(cat "$dotest/msgnum")
d5e673b6 189 msgnum=$(($msgnum + 1))
889a50e9 190 onto=$(cat "$dotest/onto")
d5e673b6
EW
191 while test "$msgnum" -le "$end"
192 do
193 call_merge "$msgnum"
194 continue_merge
195 done
196 finish_rb_merge
197 exit
58634dbf 198 fi
6fd2f5e6
JS
199 head_name=$(cat .dotest/head-name) &&
200 onto=$(cat .dotest/onto) &&
201 orig_head=$(cat .dotest/orig-head) &&
202 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
203 move_to_original_branch
031321c6
SE
204 exit
205 ;;
206 --abort)
b4372ef1 207 git rerere clear
58634dbf
EW
208 if test -d "$dotest"
209 then
6fd2f5e6 210 move_to_original_branch
58634dbf
EW
211 elif test -d .dotest
212 then
6fd2f5e6
JS
213 dotest=.dotest
214 move_to_original_branch
58634dbf
EW
215 else
216 die "No rebase in progress?"
217 fi
48411d22
MH
218 git reset --hard $(cat $dotest/orig-head)
219 rm -r "$dotest"
031321c6
SE
220 exit
221 ;;
e646c9c8
JH
222 --onto)
223 test 2 -le "$#" || usage
224 newbase="$2"
225 shift
226 ;;
58634dbf
EW
227 -M|-m|--m|--me|--mer|--merg|--merge)
228 do_merge=t
229 ;;
230 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
231 --strateg=*|--strategy=*|\
232 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
233 case "$#,$1" in
234 *,*=*)
8096fae7 235 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
58634dbf
EW
236 1,*)
237 usage ;;
238 *)
239 strategy="$2"
240 shift ;;
241 esac
242 do_merge=t
243 ;;
b758789c
RS
244 -v|--verbose)
245 verbose=t
246 ;;
059f446d
BF
247 --whitespace=*)
248 git_am_opt="$git_am_opt $1"
249 ;;
67dad687 250 -C*)
059f446d 251 git_am_opt="$git_am_opt $1"
67dad687 252 ;;
e646c9c8
JH
253 -*)
254 usage
255 ;;
256 *)
257 break
258 ;;
259 esac
260 shift
261done
2db8aaec 262
7f4bd5d8 263# Make sure we do not have .dotest
58634dbf 264if test -z "$do_merge"
7f4bd5d8 265then
58634dbf
EW
266 if mkdir .dotest
267 then
268 rmdir .dotest
269 else
270 echo >&2 '
7f4bd5d8
JH
271It seems that I cannot create a .dotest directory, and I wonder if you
272are in the middle of patch application or another rebase. If that is not
273the case, please rm -fr .dotest and run me again. I am stopping in case
274you still have something valuable there.'
58634dbf
EW
275 exit 1
276 fi
277else
278 if test -d "$dotest"
279 then
280 die "previous dotest directory $dotest still exists." \
281 'try git-rebase < --continue | --abort >'
282 fi
7f4bd5d8
JH
283fi
284
7f59dbbb 285# The tree must be really really clean.
5be60078 286git update-index --refresh || exit
38762c47 287diff=$(git diff-index --cached --name-status -r HEAD --)
32d99544 288case "$diff" in
6e598c32
DK
289?*) echo "cannot rebase: your index is not up-to-date"
290 echo "$diff"
7f59dbbb
JH
291 exit 1
292 ;;
293esac
99a92f92 294
e646c9c8
JH
295# The upstream head must be given. Make sure it is valid.
296upstream_name="$1"
297upstream=`git rev-parse --verify "${upstream_name}^0"` ||
d0080b3c 298 die "invalid upstream $upstream_name"
32d99544 299
a1bf91e0
JH
300# Make sure the branch to rebase onto is valid.
301onto_name=${newbase-"$upstream_name"}
5be60078 302onto=$(git rev-parse --verify "${onto_name}^0") || exit
a1bf91e0 303
9a111c91
JH
304# If a hook exists, give it a chance to interrupt
305if test -x "$GIT_DIR/hooks/pre-rebase"
306then
307 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
308 echo >&2 "The pre-rebase hook refused to rebase."
309 exit 1
310 }
311fi
312
7f59dbbb 313# If the branch to rebase is given, first switch to it.
59e6b23a 314case "$#" in
7f59dbbb 3152)
e646c9c8 316 branch_name="$2"
3ae39ab2 317 git-checkout "$2" || usage
e646c9c8
JH
318 ;;
319*)
bcf31618
JH
320 if branch_name=`git symbolic-ref -q HEAD`
321 then
322 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
323 else
324 branch_name=HEAD ;# detached
325 fi
e646c9c8 326 ;;
59e6b23a 327esac
5be60078 328branch=$(git rev-parse --verify "${branch_name}^0") || exit
59e6b23a 329
e646c9c8
JH
330# Now we are rebasing commits $upstream..$branch on top of $onto
331
1308c17b
JS
332# Check if we are already based on $onto with linear history,
333# but this should be done only when upstream and onto are the same.
5be60078 334mb=$(git merge-base "$onto" "$branch")
1308c17b
JS
335if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
336 # linear history?
337 ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
7f4bd5d8 338then
83c31614
RS
339 echo >&2 "Current branch $branch_name is up to date."
340 exit 0
7f4bd5d8
JH
341fi
342
b758789c
RS
343if test -n "$verbose"
344then
345 echo "Changes from $mb to $onto:"
fefe49d1 346 # We want color (if set), but no pager
5be60078 347 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
b758789c
RS
348fi
349
6fd2f5e6
JS
350# move to a detached HEAD
351orig_head=$(git rev-parse HEAD^0)
352head_name=$(git symbolic-ref HEAD 2> /dev/null)
353case "$head_name" in
354'')
355 head_name="detached HEAD"
356 ;;
357*)
358 git checkout "$orig_head" > /dev/null 2>&1 ||
359 die "could not detach HEAD"
360 ;;
361esac
362
e646c9c8 363# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
228e2eb6 364echo "First, rewinding head to replay your work on top of it..."
e646c9c8 365git-reset --hard "$onto"
32d99544 366
e646c9c8 367# If the $onto is a proper descendant of the tip of the branch, then
32d99544 368# we just fast forwarded.
83c31614 369if test "$mb" = "$branch"
32d99544 370then
d587ed13 371 echo >&2 "Fast-forwarded $branch_name to $onto_name."
6fd2f5e6 372 move_to_original_branch
32d99544
LS
373 exit 0
374fi
375
58634dbf
EW
376if test -z "$do_merge"
377then
5be60078 378 git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
6fd2f5e6
JS
379 git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG" &&
380 move_to_original_branch
381 ret=$?
382 test 0 != $ret -a -d .dotest &&
383 echo $head_name > .dotest/head-name &&
384 echo $onto > .dotest/onto &&
385 echo $orig_head > .dotest/orig-head
386 exit $ret
58634dbf
EW
387fi
388
389# start doing a rebase with git-merge
390# this is rename-aware if the recursive (default) strategy is used
391
392mkdir -p "$dotest"
393echo "$onto" > "$dotest/onto"
0bb733c9 394echo "$onto_name" > "$dotest/onto_name"
6fd2f5e6 395prev_head=$orig_head
58634dbf 396echo "$prev_head" > "$dotest/prev_head"
6fd2f5e6
JS
397echo "$orig_head" > "$dotest/orig-head"
398echo "$head_name" > "$dotest/head-name"
58634dbf
EW
399
400msgnum=0
5be60078 401for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
58634dbf
EW
402do
403 msgnum=$(($msgnum + 1))
5887ac82 404 echo "$cmt" > "$dotest/cmt.$msgnum"
58634dbf
EW
405done
406
5887ac82
JH
407echo 1 >"$dotest/msgnum"
408echo $msgnum >"$dotest/end"
58634dbf
EW
409
410end=$msgnum
411msgnum=1
412
413while test "$msgnum" -le "$end"
414do
415 call_merge "$msgnum"
416 continue_merge
417done
cc120056 418
58634dbf 419finish_rb_merge